// Datei: Repeater.c
// 433MHz Repeater fr RC5 Infrarot Signale
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 02.06.2001
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor

#include "repeater.h"
#include "protos.h"

#define REPEAT 8  //Anzahl der Code Sendungen auf 433MHz

#include "lcd.c"
#include "bin2bcd8.c"
#include "delay.c"
#include "phase.c"
#include "phasemod.c"

unsigned char shift;   //Register fr die Abtastung
unsigned char subcode; //Der RC5 Gertecode
unsigned char comcode; //Der RC5 Kommandocode
unsigned char toggle;  //Das Togglebit
unsigned char combuf;  //Puffer fr Sub-,Kommandocode und Togglebit. Fr Verify
unsigned char subbuf;
unsigned char togbuf;

//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char by,i;
 
 CLRWDT;	    //Vor ndern des Prescalers auf Timer0 laut Microchip

//Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b10000010; //Pullups off,Prescaler auf TMR0, 1:8

 TRISA=0b11100000;   //Alles Eingnge bis auf pa0
 TRISB=0b00000001;   //PB7..1 Ausgnge , PB0 Eingang
 PORTB=0x02;
 PORTA=0x00;

 LCDCS_ON(); 	//LCD-Anzeige deaktivieren
 LCDRS_OFF();   //LCD-Datenregister


 LCDInit(); //LCD-Anzeige initialisieren !!
 LCDCls();  //Sonst bleibt manchmal Dreck in der Anzeige stehen
 LCDWrite("Holgi's");
 LCDPos(2,1);
 LCDWrite("RC5 Test");
 
 shift=0; //Empfangsregister lschen

// Dauersendung zu Testzwecken
// toggle=1; subcode=20; comcode=53; //CD Player Play Taste
// while(1) PhaseMod();
 
 while(1) // Programm-Endlosschleife
  {

   do
    {
     by=PhaseDemod(); //Warten auf RC5 Code
    }while(by==0);    //Bis by>0

   combuf=comcode; //Eben empfangenen Code speichern
   subbuf=subcode;
   togbuf=toggle;
   
   do //Code ein zweites mal empfangen
    {
     by=PhaseDemod(); //Warten auf RC5 Code
    }while(by==0);    //Bis by>0


//   if(comcode==combuf && subcode==subbuf && toggle==togbuf) //Beide Codes gleich ?
   if(comcode==combuf && subcode==subbuf) //Beide Codes gleich ?
    {
     LCDCls();
     LCDPos(1,1); LCDWrite("Ad:");
     B0=subcode; //Gertecode in BCD umrechnen
     BinToBCD8(); //Ergebnis in R1 !
     ShowBCD(R1); //Gertecode anzeigen

     LCDWrite(" T"); //ToggleBit anzeigen
     if(toggle==ONE) LCDWriteByte(0x31); //Eine 1
     else            LCDWriteByte(0x30); //Eine 0
     
     LCDPos(2,1); LCDWrite("Cm:");
     B0=comcode; //Kommandocode in BCD umrechnen
     BinToBCD8(); //Ergebnis in R1 !

     R0+=0x30;
     LCDWriteByte(R0);
     ShowBCD(R1); //Kommandocode anzeigen

     LED_OFF();  //Empfangsled lschen

     for(i=0; i<REPEAT; i++) PhaseMod(); //Code wieder raussenden
     
    } //if(comcode==combuf && subcode==subbuf)
   
  } //while(1) Endlosschleife

}
